/*@ axiomatic Fact {
  @ logic integer Fact(integer n);
  @ axiom Fact_1: Fact(1) == 1;
  @ axiom Fact_rec: \forall integer n; n > 1 ==> Fact(n) == n * Fact(n-1);
  @ } */

/*@ requires n > 0;
  ensures \result == Fact(n);
*/
int fact(int n) {
  int y = 1;
  int x = n;
  /*@ loop invariant x >= 1 &&
                     Fact(n) == y * Fact(x);
    loop assigns x, y;
   */
  while (x != 1) {
    y = y * x;
    x = x - 1;
  };
  return y;
}
